#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <string.h>
#include "grb2.h"
#include "wgrib2.h"
#include "fnlist.h"

/*
 * set_byte
 *
 * routine to modify grib fields
 *
 * 3/2008 Public Domain by Wesley Ebisuzaki
 *
 */

/*
 * HEADER:100:set_byte:misc:3:set bytes in Section X, location Y (1..N), bytes Z (a|a:b:c)
 */

int f_set_byte(ARG3) {

    int i, j, k, m, val, seclen;
    if (mode < 0) {
        i = atoi(arg1);
	if (i < 0 || i > 8) fatal_error("set_byte - bad section number %s", arg1);
	return 0;
    }

    i = atoi(arg1);
    j = atoi(arg2);

    if (i == 0) seclen = GB2_Sec0_size;
    else if (i == 8)  seclen = GB2_Sec8_size;
    else seclen = uint4(sec[i]);

    k = sscanf(arg3, "%d%n", &val, &m);
    while (k == 1) {
	if (j > seclen) fatal_error("set_byte out of bounds section %s",arg1);
	sec[i][j++ -1] = val;
	arg3 += m;
        k = sscanf(arg3, ":%d%n", &val, &m);
    }
    return 0;
}
